<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>List students</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
  </head>

  <body>
    <div class="container w-50">
      <div class="text-center m-3">
        <h3 style="color: rgb(96, 96, 188);">THÔNG TIN SINH VIÊN</h3>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <button class="btn btn-primary" onclick="onBtnLayThongTinClick()">
            Lấy thông tin
          </button>
        </div>
        <label class="col-form-label col-sm-4"
          >Số lượng sinh viên:
          <span id="span-num-students" class="text-danger font-weight-bold"
            >1000</span
          >
        </label>
      </div>
      <div class="row form-group">
        <div class="col-sm-12">
          Danh sách ID sinh viên:
          <span id="span-id-student-list" class="text-danger"
            >3, 4, 7, 8, 9, 10</span
          >
        </div>
      </div>
      <br />
      <hr />
      <div class="row form-group">
        <label class="col-form-label col-sm-4" for="input-student-id"
          >Nhập Id sinh viên <span class="text-danger">(*)</span></label
        >
        <div class="col-sm-5">
          <input
            id="input-student-id"
            placeholder="Nhập id sinh viên ..."
            class="form-control"
          />
        </div>
        <div class="col-sm-3">
          <button class="btn btn-primary" onclick="onBtnXemChiTietClick()">
            Xem chi tiết
          </button>
        </div>
      </div>
      <hr />
      <div class="row form-group">
        <label class="col-form-label col-sm-3" for="input-student-code"
          >Student Code</label
        >
        <div class="col-sm-3">
          <input
            id="input-student-code"
            placeholder="Student Code"
            class="form-control"
          />
        </div>
        <label class="col-form-label col-sm-3" for="input-username"
          >Username</label
        >
        <div class="col-sm-3">
          <input
            id="input-username"
            placeholder="Username"
            class="form-control"
          />
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-3" for="input-firstname"
          >First name</label
        >
        <div class="col-sm-3">
          <input
            id="input-firstname"
            placeholder="First name"
            class="form-control"
          />
        </div>
        <label class="col-form-label col-sm-3" for="input-lastname"
          >Last name</label
        >
        <div class="col-sm-3">
          <input
            id="input-lastname"
            placeholder="Last name"
            class="form-control"
          />
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-3" for="input-birthday"
          >Birthday</label
        >
        <div class="col-sm-3">
          <input
            type="text"
            id="input-birthday"
            placeholder="Birthday"
            class="form-control"
          />
        </div>
        <label class="col-form-label col-sm-3" for="input-study-year"
          >Study year</label
        >
        <div class="col-sm-3">
          <input
            type="text"
            id="input-study-year"
            placeholder="Study year"
            class="form-control"
          />
        </div>
      </div>
      <div class="row form-group">
        <label class="col-form-label col-sm-3" for="input-email">Email</label>
        <div class="col-sm-9">
          <input
            type="text"
            id="input-email"
            placeholder="Email"
            class="form-control"
          />
        </div>
      </div>
    </div>
  </body>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_FINISH_AND_OK = 200;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi nút Lấy thông tin được click
    function onBtnLayThongTinClick() {
      "use strict";
      // Bước 3: Xử lý Ajax
      // tạo ra đối tượng request và gửi đi
      var vXmlHttp = new XMLHttpRequest();
      processAjax(vXmlHttp);
      // nhận về response và xử lý

      var vStatusCode = vXmlHttp.status;
      // nếu trạng thái trả về thành công!
      if (vStatusCode == gREQUEST_STATUS_FINISH_AND_OK) {
        // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
        console.log(vXmlHttp.responseText);
        var bListResponse = JSON.parse(vXmlHttp.responseText);
        // Bước 4: Hiển thị kết quả
        displayData(bListResponse);
      }
    }

    //hàm thực thi khi nút Xem chi tiết được click
    function onBtnXemChiTietClick() {
      "use strict";
      // Bước 0: Tạo đối tượng chứa dữ liệu thu thập
      var vObject = {
        idSv: "",
      };
      // Bước 1: Thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: Xử lý Ajax
      if (vCheck == true) {
        // tạo ra đối tượng request và gửi đi
        var vXmlHttp = new XMLHttpRequest();
        processAjaxSv(vXmlHttp, vObject.idSv);
        // nhận về response và xử lý

        var vStatusCode = vXmlHttp.status;
        // nếu trạng thái trả về thành công!
        if (vStatusCode == gREQUEST_STATUS_FINISH_AND_OK) {
          // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
          console.log(vXmlHttp.responseText);
          var bIdSvResponse = JSON.parse(vXmlHttp.responseText);
          // Bước 4: Hiển thị kết quả
          displayDataSv(bIdSvResponse);
        } else {
          // Bước 4: Hiển thị kết quả
          alert("Không tồn tại Sinh viên với id đã nhập");
        }
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm xử lý ajax
    // Input là đối tượng request
    function processAjax(paramRequest) {
      "use strict";
      paramRequest.open(
        "GET",
        "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/students",
        false
      );
      paramRequest.send();
    }

    // Hàm hiển thị dữ liệu
    // Input là dữ liệu cần hiển thị
    function displayData(paramData) {
      "use strict";
      var vSoLuongSvSpanE = document.getElementById("span-num-students");
      var vIdsSvSpanE = document.getElementById("span-id-student-list");

      vSoLuongSvSpanE.innerHTML = paramData.length;
      vIdsSvSpanE.innerHTML = "";
      for (var bI = 0; bI < paramData.length; bI++) {
        if (bI == paramData.length - 1) {
          vIdsSvSpanE.innerHTML += paramData[bI].id;
        } else {
          vIdsSvSpanE.innerHTML += paramData[bI].id + ", ";
        }
      }
    }

    // Hàm thu thập dữ liệu Id Sinh viên
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
      "use strict";
      // lấy giá trị nhập vào
      var vElementIdSvInput = document.getElementById("input-student-id");
      var vIdSv = vElementIdSvInput.value;
      paramObject.idSv = vIdSv;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là true / false
    function validateData(paramObject) {
      "use strict";
      var vResult = true;

      var vIdSv = paramObject.idSv.trim();

      if (vIdSv == "") {
        alert("Bạn chưa nhập ID sinh viên!");
        vResult = false;
      }

      if (isNaN(vIdSv)) {
        alert("ID sinh viên phải là số!");
        vResult = false;
      }

      return vResult;
    }

    // Hàm xử lý ajax cho chi tiết sinh viên
    // Input là đối tượng request và mã voucher
    function processAjaxSv(paramRequest, paramIdSv) {
      "use strict";
      paramRequest.open(
        "GET",
        "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/students/" +
          paramIdSv,
        false
      );
      paramRequest.send();
    }

    // Hàm hiển thị dữ liệu chi tiết sinh viên
    // Input là dữ liệu cần hiển thị
    function displayDataSv(paramData) {
      "use strict";
      var vStudentCodeInputE = document.getElementById("input-student-code");
      var vUsernameInputE = document.getElementById("input-username");
      var vFirstnameInputE = document.getElementById("input-firstname");
      var vLastnameInputE = document.getElementById("input-lastname");
      var vBirthdayInputE = document.getElementById("input-birthday");
      var vStudyYearInputE = document.getElementById("input-study-year");
      var vEmailInputE = document.getElementById("input-email");

      vStudentCodeInputE.value = paramData.studentCode;
      vUsernameInputE.value = paramData.username;
      vFirstnameInputE.value = paramData.firstname;
      vLastnameInputE.value = paramData.lastname;
      vBirthdayInputE.value = paramData.birthday;
      vStudyYearInputE.value = paramData.studyYear;
      vEmailInputE.value = paramData.email;
    }
  </script>
</html>
